import sched
import time
import datetime
import subprocess

s=sched.scheduler(time.time,time.sleep)
JST=datetime.timezone(datetime.timedelta(hours=+9),'JST')
UTF8_BOM=bytearray([0xEF,0xBB,0xBF]).decode()
str_s=open('/mnt/nas/radiocfg.txt','r').readlines()

def strip_bom(s):
    if s.startswith(UTF8_BOM):
        return s[len(UTF8_BOM):]
    return s

def writelog(logtext):
    logfile=open('/mnt/nas/log.txt','a')
    logfile.write(datetime.datetime.now(JST).strftime('%Y%m%d %H%M%S:')+str(logtext)+'\n')
    logfile.close()

def record(len,title):
    now=datetime.datetime.now(JST)
    url='https://nhkradioakr2-i.akamaihd.net/hls/live/511929/1-r2/1-r2-01.m3u8'
    fname='/mnt/nas/'+str(now.strftime('%Y%m%d_%H%M%S_'))+title+'.mp3'
    writelog(fname)
    try:
        p=subprocess.Popen(['ffmpeg','-i',url,'-to',len,fname])
    except:
        writelog('Error url:'+url+'filename:'+fname+'length:'+len+'title:'+title)


def update():
    map(s.cancel,s.queue)
    subprocess.Popen('sleep 5 && { sudo apt-get update && sudo apt-get -y upgrade && sudo apt-get -y dist-upgrade && sudo apt-get -y autoremove && sudo apt-get -y autoclean && echo "complete!" ; } > /mnt/nas/updlog.txt ; init 6; ',shell=True)
    writelog('Update:Exit')
    exit()



now=datetime.datetime.now(JST)
dt=datetime.datetime(now.year,now.month,now.day,0,0,0,tzinfo=JST).timestamp()
writelog('started')
for elem in str_s:
    syobi,rectimes,slen,stitle=strip_bom(elem).rstrip('\n').split(' ',3)
    shour,smin,ssec=rectimes.split(':',2)
    tyobi=now.weekday()
    yobi=int(syobi)
    hour=int(shour)
    min=int(smin)
    sec=int(ssec)
    if(tyobi==yobi):
        if(datetime.datetime(now.year,now.month,now.day,hour,min,sec,tzinfo=JST)>now):
            day=0
        else:
            day=7
    elif (tyobi<yobi):
        day=yobi-tyobi
    elif (tyobi>yobi):
        day=7-tyobi+yobi
    ts=dt+86400*day+3600*hour+60*min+sec
    if(int(slen)<0):
        s.enterabs(ts,1,update)
    else:
        s.enterabs(ts,1,record,(slen,stitle,))

writelog(s.queue)
s.run()
